org.apache.datasketches.kll

## Enum KllSketch.SketchStructure

- java.lang.Object
- - java.lang.Enum<KllSketch.SketchStructure>
  - - org.apache.datasketches.kll.KllSketch.SketchStructure

All Implemented Interfaces:
  Serializable, Comparable<KllSketch.SketchStructure>

Enclosing class:
  KllSketch

    public static enum KllSketch.SketchStructure
    extends Enum<KllSketch.SketchStructure>

Used primarily to define the structure of the serialized sketch. Also used by the Heap Sketch.

### Enum Constant Summary

Enum Constants
Enum Constant and Description
`COMPACT_EMPTY` Compact Empty Structure
`COMPACT_FULL` Compact Full Preamble Structure
`COMPACT_SINGLE` Compact Single Item Structure
`UPDATABLE` Updatable Preamble Structure

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`int` `getPreInts()` gets the Preamble Integers for this Structure.
`int` `getSerVer()` gets the Serialization Version for this Structure.
`static KllSketch.SketchStructure` `getSketchStructure(int preInts, int serVer)` gets the SketchStructure given preInts and serVer.
`static KllSketch.SketchStructure` `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static KllSketch.SketchStructure[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### COMPACT_EMPTY

    public static final KllSketch.SketchStructure COMPACT_EMPTY

Compact Empty Structure

#### COMPACT_SINGLE

    public static final KllSketch.SketchStructure COMPACT_SINGLE

Compact Single Item Structure

#### COMPACT_FULL

    public static final KllSketch.SketchStructure COMPACT_FULL

Compact Full Preamble Structure

#### UPDATABLE

    public static final KllSketch.SketchStructure UPDATABLE

Updatable Preamble Structure

### Method Detail

#### values

    public static KllSketch.SketchStructure[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (KllSketch.SketchStructure c : KllSketch.SketchStructure.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static KllSketch.SketchStructure valueOf(String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum type has no constant with the specified name
  `NullPointerException` - if the argument is null

#### getPreInts

    public int getPreInts()

gets the Preamble Integers for this Structure.

Returns:
  the Preamble Integers for this Structure

#### getSerVer

    public int getSerVer()

gets the Serialization Version for this Structure.

Returns:
  the Serialization Version for this Structure.

#### getSketchStructure

    public static KllSketch.SketchStructure getSketchStructure(int preInts,
                                                               int serVer)

gets the SketchStructure given preInts and serVer.

Parameters:
  `preInts` - the given preamble size in integers
  `serVer` - the given Serialization Version
Returns:
  the SketchStructure given preInts and serVer.